From 121365cf0ff935b8c252c72a3b4fe9ee44d456a3 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 6/32] Issues: Invalidate cache on fedmsg


---

diff --git a/hubs/static/client/app/widgets/issues/Config.js b/hubs/static/client/app/widgets/issues/Config.js
index dc61da2..82714f2 100644
--- a/hubs/static/client/app/widgets/issues/Config.js
+++ b/hubs/static/client/app/widgets/issues/Config.js
@@ -36,10 +36,10 @@ class Config extends React.Component {
                 <select className="form-control"
                         value={this.props.values.mode}
                         onChange={this.handleModeChanged}>
-                    <option value="1">
+                    <option value="author">
                         <FormattedMessage {...messages.select_author} />
                     </option>
-                    <option value="2">
+                    <option value="assignee">
                         <FormattedMessage {...messages.select_assignee} />
                     </option>
                 </select>
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index 986f7d7..cebd3e1 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -10,13 +10,13 @@ from .functions import *
 
 class Issues(Widget):
 
-    name = "issues"
-    label = "Issues"
-    position = "both"
+    name = 'issues'
+    label = 'Issues'
+    position = 'both'
     parameters = [
         dict(
-            name="mode",
-            default="1",
+            name='mode',
+            default='author',
         )
     ]
     is_react = True
@@ -27,10 +27,10 @@ class Issues(Widget):
             hub_name = instance.hub.name
             props.update(dict(
                 title="Issues - " +
-                      ("Tickets I Filed" if int(instance.config["mode"]) == 1 else "Tickets Waiting on Me"),
+                      ('Tickets I Filed' if instance.config['mode'] == 'author' else 'Tickets Waiting on Me'),
                 urls=dict(
                     data=flask.url_for(
-                        "issues_data", hub=hub_name, idx=instance.idx),
+                        'issues_data', hub=hub_name, idx=instance.idx),
                 )
             ))
         return props
@@ -49,7 +49,7 @@ class DataView(WidgetView):
         [github, ghcnt] = GetGithubIssues(instance)()
 
         all_issues = bugzilla + pagure + github
-        all_issues.sort(key=lambda x: arrow.get(x["updated_at"]), reverse=True)
+        all_issues.sort(key=lambda x: arrow.get(x['updated_at']), reverse=True)
 
-        data = {"issues": all_issues, "counts": {"bugzilla": bzcnt, "pagure": pcnt, "github": ghcnt}}
-        return dict(status="OK", data=data)
+        data = {'issues': all_issues, 'counts': {'bugzilla': bzcnt, 'pagure': pcnt, 'github': ghcnt}}
+        return dict(status='OK', data=data)
diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
index 4be18f4..6d79923 100644
--- a/hubs/widgets/issues/functions.py
+++ b/hubs/widgets/issues/functions.py
@@ -6,9 +6,9 @@ from hubs.widgets.caching import CachedFunction
 class GetBugzillaBugs(CachedFunction):
 
     def execute(self):
-        email = self.instance.hub.config["bugzilla_email"]
-        endpoint = "https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{\"{}\":\"{}\"}}]"
-        mode = "creator" if self.instance.config["mode"] == "1" else "assigned_to"
+        email = self.instance.hub.config['bugzilla_email']
+        endpoint = 'https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{"{}":"{}"}}]'
+        mode = 'creator' if self.instance.config['mode'] == 'author' else 'assigned_to'
         response = requests.get(endpoint.format(mode, email)).json()
         issues = response['result']['bugs']
         issues = issues[:min(5, len(issues))]
@@ -28,20 +28,24 @@ class GetBugzillaBugs(CachedFunction):
         return [res, total_count]
 
     def should_invalidate(self, message):
-        return False
+        email = self.instance.hub.config('bugzilla_email')
+        mode = self.instance.config['mode']
+        if message['topic'].endswith('bugzilla.bug.new') or \
+           message['topic'].endswith('bugzilla.bug.update'):
+            return message['msg']['bug']['creator' if mode == 'author' else 'assigned_to'] == email
 
     def should_invalidate_on_hub_config_change(self, old_config):
-        return True
+        return old_config['bugzilla_email'] != self.instance.hub.config['bugzilla_email']
 
 
 class GetPagureIssues(CachedFunction):
 
     def execute(self):
-        username = self.instance.hub.config["pagure_username"]
+        username = self.instance.hub.config['pagure_username']
         endpoint = "https://pagure.io/api/0/user/{}/issues?author={}"
-        author = "true" if self.instance.config["mode"] == "1" else "false"
+        author = self.instance.config['mode'] == 'author'
         response = requests.get(endpoint.format(username, author)).json()
-        issues = response['issues_created'] if author == "true" else response['issues_assigned']
+        issues = response['issues_created'] if author else response['issues_assigned']
         issues = issues[:min(5, len(issues))]
         urltmpl = 'https://pagure.io/{}/issue/{}'
         res = []
@@ -55,14 +59,24 @@ class GetPagureIssues(CachedFunction):
                 service='pagure',
                 icon='https://pagure.io/static/favicon.ico'
             ))
-        total_count = len(response['issues_created'] if author == "true" else response['issues_assigned'])
+        total_count = len(response['issues_created'] if author else response['issues_assigned'])
         return [res, total_count]
 
     def should_invalidate(self, message):
-        return False
+        mode = self.instance.config['mode']
+        username = self.instance.hub.config('pagure_username')
+        if message['topic'].endswith('pagure.issue.new') or \
+           message['topic'].endswith('pagure.issue.edit') or \
+           message['topic'].endswith('pagure.issue.assigned.added') or \
+           message['topic'].endswith('pagure.issue.assigned.reset') or \
+           message['topic'].endswith('pagure.issue.drop'):
+            if mode == 'author':
+                return message['msg']['user']['name'] == username
+            elif mode == 'assignee':
+                return message['msg']['assignee']['name'] == username
 
     def should_invalidate_on_hub_config_change(self, old_config):
-        return True
+        return old_config['pagure_username'] != self.instance.hub.config['pagure_username']
 
 
 class GetGithubIssues(CachedFunction):
@@ -70,7 +84,7 @@ class GetGithubIssues(CachedFunction):
     def execute(self):
         username = self.instance.hub.config["github_username"]
         endpoint = "https://api.github.com/search/issues?q=type:issue+{}:{}+state:open&sort:updated"
-        mode = "author" if self.instance.config["mode"] == "1" else "assignee"
+        mode = "author" if self.instance.config['mode'] == 'author' else "assignee"
         response = requests.get(endpoint.format(mode, username)).json()
         issues = response['items']
         issues = issues[:min(5, len(issues))]
@@ -92,4 +106,4 @@ class GetGithubIssues(CachedFunction):
         return False
 
     def should_invalidate_on_hub_config_change(self, old_config):
-        return True
+        return old_config['github_username'] != self.instance.hub.config['github_username']

